/***************************************************************************
                          verkauf_rechnung.h  -  description
                             -------------------
    begin                : Wed Aug 9 2000
    version              : $Id: verkauf_rechnung.h,v 1.9 2000/09/16 18:25:54 joerg_bemme Exp $
    copyright            : (C) 2000 by Jrg Bemm
    email                : info@bemme.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VERKAUF_RECHNUNG_H
#define VERKAUF_RECHNUNG_H

#include "qdbmenudialog.h"
#include "qdbtableedit.h"
#include "buchen.h"

/**creating and managing invoices
  *@author Jrg Bemm
  */

class Verkauf_Rechnung : public QWidget  {
   Q_OBJECT
public: 
	Verkauf_Rechnung(QWidget *parent=0, const char *name=0,
								SQLQuerier *sql_ptr=0 );
	~Verkauf_Rechnung();

	QStatusBar *statusBar;

private:
	void setDebitorValue( SQLTable *t=0,
					const char *fieldDebitor=0, const char *fieldKopf=0 );
	void initPositions();
	QString *getPosValue( const char *fieldname );

	QDBMenuDialog *dialog;
	SQLTable *tableKopf;
	SQLTable *tableZeilen;
	QDBTableEdit *positions;
	QPopupMenu *accounting;
  QVBoxLayout *topLayoutZeilen;
	QWidget *zeilen;
	QString *strPtr;
	Buchen *buchen;

private slots:
	void sBuchen();
	void sCalcPositions();
	void getLfdNr();
	void setDefaults();
	void getNewInvoiceNo();
	void enableZeilen();
	void setFields( const char *fieldname );
};

#endif
